{********************************************************
 * Demo2 application                                    *
 *                                                      *
 * This sample outline a simple acounting application   *
 * where in separate way of the main application is     *
 * possible to register the following optional modules: *
 *                                                      *
 *     1. General Ledger                                *
 *     2. Receivable                                    *
 *     3. Payable                                       *
 *     4. Utilities                                     *
 *                                                      *
 *     Part of the AVLock Gold package                  *
 *     (c) Alcides Valega, 2002                         *
 ********************************************************}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, AVLockGold;

type
  TForm1 = class(TForm)
    MM1: TMainMenu;
    Modulo11: TMenuItem;
    Item111: TMenuItem;
    Item121: TMenuItem;
    Modulo21: TMenuItem;
    Item211: TMenuItem;
    Item221: TMenuItem;
    m1Opcin31: TMenuItem;
    Modulo31: TMenuItem;
    m3Opcin11: TMenuItem;
    m3Opcin21: TMenuItem;
    m3Opcin31: TMenuItem;
    Modulo41: TMenuItem;
    m4Opcin11: TMenuItem;
    m4Opcin21: TMenuItem;
    Archivos1: TMenuItem;
    Salir1: TMenuItem;
    Registrar1: TMenuItem;
    AVLockGold1: TAVLockGold;
    procedure FormCreate(Sender: TObject);
    procedure Registrar1Click(Sender: TObject);
    procedure Item111Click(Sender: TObject);
    procedure Item121Click(Sender: TObject);
    procedure m1Opcin31Click(Sender: TObject);
    procedure Item211Click(Sender: TObject);
    procedure Item221Click(Sender: TObject);
    procedure m3Opcin11Click(Sender: TObject);
    procedure m3Opcin21Click(Sender: TObject);
    procedure m3Opcin31Click(Sender: TObject);
    procedure m4Opcin11Click(Sender: TObject);
    procedure m4Opcin21Click(Sender: TObject);
    procedure Salir1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure regstat(list:tstrings);
    Procedure setmodules;
    function MyExecute(force:boolean):boolean;
    procedure legend(m,i:integer);
  end;

var
  Form1: TForm1;

implementation
uses RegUnit1;
{$R *.DFM}

procedure TForm1.regstat(list:tstrings);
var s,s1:string;
    i:byte;
    dat,day,usrs:word;
    regist,expir,authoriz:boolean;
begin
  with AVLockGold1 do begin
    read;
    list.Clear;
    if (error=-1) then begin
      list.Add(' ------ Registration data not found ------');
      exit;
    end;
    s:='';
    if (error>=0) then begin
      FmtStr(s,' Main   %3d    ',[users]);
      if registered then s:=s+'Permanent                                '
      else if authorized then s:=s+'Temporary     '
      else s:=s+'Trial         ';
      if not registered then begin
        s:=s+formatdatetime('mm/dd/yy  ',begindate)
        +formatdatetime('mm/dd/yy  ',enddate);
        if expired then FmtStr(s1,'%4d  Expired',[days])
        else FmtStr(s1,'%4d %4d ',[days,trunc(enddate-now+1)]);
        s:=s+s1;
      end;
      list.Add(s);
    end;
    for i:=0 to maxmodules do begin
      case i of
        1:s:=' G.Ledg ';
        2:s:=' Receiv ';
        3:s:=' Payabl ';
        4:s:=' Utilit ';
        else FmtStr(s,'%4d   ',[i]);
      end;
      error:=0;
      readmodule(i,dat,day,usrs,expir,regist,authoriz);
      if (error=0) then begin
        FmtStr(s1,'%3d    ',[usrs]);
        s:=s+s1;
        if regist then s:=s+'Permanent '
        else s:=s+'Temporary     ';
        if not regist then begin
          s:=s+formatdatetime('mm/dd/yy  ',dat)
          +formatdatetime('mm/dd/yy  ',dat+day);
          FmtStr(s1,'%4d    ',[day]);
          if expir then FmtStr(s1,'%4d  Expired',[day])
          else FmtStr(s1,'%4d %4d ',[day,trunc(dat+day-now+1)]);
          s:=s+s1;
        end;
        list.Add(s);
      end;
    end;
  end;
end;


Procedure TForm1.setmodules;
begin
  MM1.Items[1].visible := AVLockGold1.moduleok(1);
  MM1.Items[2].visible := AVLockGold1.moduleok(2);
  MM1.Items[3].visible := AVLockGold1.moduleok(3);
  MM1.Items[4].visible := AVLockGold1.moduleok(4);
end;

function TForm1.MyExecute(force:boolean):boolean;
var F:TRegForm1;
    err:integer;
    regcod,s:string;
    day,dat,usrs,modl,i,j:word;
    ndsk:dword;
begin
  Result:=False;
  avlockgold1.Read;
  setmodules;
  with avlockgold1 do begin
    if firsttime then maketrial;
    if Authorized then writelastdate;
    if not warning and (Registered or (Authorized and not Expired)) then Result:=True;
    if not result or force then begin
      WriteLastDate;
      Result:=False;
      F:=TRegForm1.Create(nil);
      try
      F.Caption:=AppName;
      F.LInstalCode.Caption:=Instalcode;
      F.BtnOk.Enabled:=not expired;
      F.memo3.Font :=avlockgold1.Font;
      regstat(F.Memo2.lines);

      if expired then begin
        F.memo1.lines.add(TextExpired);
        F.Lexpire.caption:='Trial period expired.';
      end else begin
        if registered then F.Lexpire.caption:='Application registered.'
        else F.Lexpire.caption:='You are in the day '+inttostr(trunc(now-begindate+1))
        +' of your '+inttostr(days)+' day evaluation period.';

        if warning then F.memo1.lines.add(TextWarning)
        else if not registered and not authorized
        then F.memo1.lines.add(TextCongratulation);
      end;

      F.Panel3.visible:=(UserName in AVLockGold1.InstalCodeSources);
      F.Panel2.Visible:=not F.Panel3.visible;
      F.ClientWidth:=F.BtnOk.Left+F.btnOk.Width+15;
      F.ClientHeight:=F.Panel5.Top+F.Panel5.Height+15;

      F.ShowModal;
      if F.modalresult = mrYes then with avlockgold1 do begin
        if (UserName in InstalCodeSources) then begin
          UserCode:=CalcUserCode(F.EdName2.Text);
          if (Usercode=0) then begin
            showmessage(PromptYouMust);
            Result:=False;
            exit;
          end;
          WriteUserCode;
          read;
        end;

        j:=0;
        for i:=0 to F.memo3.Lines.Count do begin
          regcod:=trim(F.memo3.Lines[i]);
          if (length(regcod)>0) then begin
            err:=decode(regcod,dat,day,usrs,modl);
            if (err=0) then begin
              if (usrs=0) then erasereg(modl)   //unregister
              else if (modl in[0,255]) then begin
                write(regcod);
                read;
              end else begin
                writemodule(regcod);
              end;
              inc(j);
              if not expired then Result:=True;
            end else showmessage(PromptInvalidCode);
          end;
        end;
        showmessage(inttostr(j)+' '+PromptRegistered);
        F.Panel1.Visible := not registered and not expired;
      end;
      if (F.modalresult = mrOk) then Result:=True;

      finally
      F.Free;
      end;
    end;
  end;
end;



procedure TForm1.FormCreate(Sender: TObject);
begin
  if not myExecute(false) then application.Terminate;
end;

procedure TForm1.legend(m,i:integer);
begin
  showmessage('Module: '+inttostr(m)+'       Item: '+inttostr(i)+#13#10+
  '--------------------------------------------'+#13#10+
  'Sample program for the AVLock Gold component');
end;

procedure TForm1.Registrar1Click(Sender: TObject);
begin
  myexecute(true);
end;

procedure TForm1.Item111Click(Sender: TObject);
begin
  legend(1,1);
end;

procedure TForm1.Item121Click(Sender: TObject);
begin
  legend(1,2);
end;

procedure TForm1.m1Opcin31Click(Sender: TObject);
begin
  legend(1,3);
end;

procedure TForm1.Item211Click(Sender: TObject);
begin
  legend(2,1);
end;

procedure TForm1.Item221Click(Sender: TObject);
begin
  legend(2,2);
end;

procedure TForm1.m3Opcin11Click(Sender: TObject);
begin
  legend(3,1);
end;

procedure TForm1.m3Opcin21Click(Sender: TObject);
begin
  legend(3,2);
end;

procedure TForm1.m3Opcin31Click(Sender: TObject);
begin
  legend(3,3);
end;

procedure TForm1.m4Opcin11Click(Sender: TObject);
begin
  legend(4,1);
end;

procedure TForm1.m4Opcin21Click(Sender: TObject);
begin
  legend(4,2);
end;

procedure TForm1.Salir1Click(Sender: TObject);
begin
  Close;
end;

end.
